'
'	(C) Copyright HiSoft 1994
'	All rights reserved.


' This program lets you embed an assembly language routine in your BASIC program
' without the need to use a Linker.
' This program converts an Amiga object file into a Basic program which
' consists of an array dimension and a TAGLIST that contains the code that you
' that was in the object file; you can then use the CALL LOC statement to call
' the machine code.

' The machine code must be position independent (use the ensure PC relative code
' option in Devpac 3) and should define (via XDEF) a single entry point at the
' start of the code. The name used in the XREF is the name used for the array

' Note that the code opens the Exec.library library 
' so that the CPU's caches can be cleared on 68040s

' the copyright of the files produced by this program remains with the author
' of the file being converted

' Feel free to modify this program, if you need to extend it for your own purposes
' but you may not distribute the source without our permission.

DEFINT a-z
' dos.bc has the constants for the different hunk types
REM $include dos.bc
	a$=LTRIM$(RTRIM$(COMMAND$))			' get the command line without leading/trailing spaced
	IF a$="" THEN
		' as the user for the files
		INPUT "Enter input (.o) file name", infile$
		INPUT "Enter output (.bas) file name", outfile$
	ELSE 
		i=INSTR(a$," ")
	' if there was a space in the name assume we have input and output files
		IF i THEN
			infile$=RTRIM$(LTRIM$(LEFT$(a$,i-1)))
			outfile$=RTRIM$(LTRIM$(MID$(a$,i+1)))
		ELSE
	' if there is only one name use this for input
			infile$=a$:outfile$=""
		END IF
	END IF

' if there is no outfile name then use the infile name if no extension was used
	IF outfile$="" THEN
		IF INSTR(infile$,".")=0 THEN
			 outfile$=infile$
		ELSE
			PRINT "No output file"
			STOP
		END IF
	END IF

	IF INSTR(infile$,".")=0 THEN infile$=infile$+".o"		' default extension for input
	IF INSTR(outfile$,".")=0 THEN outfile$=outfile$+".bas"		'default extension for output

' open the file and read the whole thing into d$
	OPEN infile$ FOR INPUT AS #1
  dlen=LOF(1)
	
	d$=INPUT$(dlen,#1)
	dx=1				' we use dx to indicate the next character we are processing

' the .o file constists of different hunks records so we read one and then
' deal appropriately until we get an END hunk - then we save the file
	DO
		ReadHunk
		SELECT CASE headertype&
		CASE HUNK_END&:	EXIT LOOP
		CASE HUNK_RELOC32&, HUNK_RELOC16&,HUNK_RELOC8&, HUNK_RELOC32SHORT&, _
			 HUNK_DRELOC32&:
			 		PRINT " Can't convert files with ";headheadertype&; "records"
					STOP  
		CASE HUNK_UNIT&, HUNK_NAME&, HUNK_DEBUG&:
		' We ignore these
		CASE HUNK_EXT&:
			ReadExtSym -1
		CASE HUNK_SYMBOL&:
			ReadExtSym 0	 		
		CASE HUNK_CODE&:
			IF code$="" THEN
					code$=headerdata$:codesize&=headersize&
			ELSE
					PRINT "Can't cope with multiple code hunks"
			END IF
		CASE HUNK_HEADER&
			ReadHunkHeader
		CASE ELSE:
			PRINT "Unknown code hunk "+HEX$(headertype&)
		END SELECT
	LOOP
	
	IF code$="" THEN PRINT "no code to convert!": STOP
	IF ourname$="" THEN
			PRINT "no XDEF name, using "; 
			i=INSTR(infile$,".")
			IF i THEN ourname$=LEFT$(infile$,i-1)
			PRINT ourname$
	END IF
	
'open our output file
	OPEN outfile$ FOR OUTPUT AS #2
' DIMension the array to be just big enough
	PRINT	#2;CHR$(9)+"DIM"+CHR$(9)+ourname$+"&("+STR$(codesize&-1)+")"
' write the first line of the TAGLIST statement
	PRINT #2;CHR$(9)+"TAGLIST VARPTR("+ourname$+"&(0))";
	
	i=1					' this counts how far we are through the code
	thisline=0
	longs_per_line=6
	
	DO
		IF thisline=0 THEN		
			PRINT #2;",  _"			' start of a new line - finish off the old one
			PRINT #2;CHR$(9);		' start the new one
		ELSE
			PRINT #2;",";
		END IF
		PRINT #2;"&H"+HEX$(CVL(MID$(code$,i,4)))+"&";: i=i+4	' output the actual code
		INCR thisline
		IF thisline=longs_per_line THEN thisline=0
	LOOP UNTIL i>codesize&*4

	PRINT #2
	PRINT #2
	PRINT #2;"	LIBRARY OPEN ""exec.library"""
	PRINT #2;"	IF PEEKW(LIBRARY(""exec.library"")+20) >= 37 THEN"
	' CacheClearE is >= V37 only, without the flush this code will
	' almost certainly not work on a 68040 (but does 1.3 work on an '040?)

	PRINT#2;"			CacheClearE VARPTR("+ourname$+"&(0)),";codesize&*4;", &h808&"	
' The constant at the end is really CACRF_ClearI& OR CACRF_ClearD& but we've expanded it
' so that there is no need to include exec.bc
	PRINT#2; "	END IF"


' the files will be closed automatically
	STOP
	
' extract a single byte from the input file that we have read into memory		
FUNCTION ReadByte%
SHARED d$,dx
ReadByte%=ASC(MID$(d$,dx,1))
INCR dx
END FUNCTION

' read a long integer into memory
FUNCTION ReadLong&
SHARED d$,dx
ReadLong&=CVL(MID$(d$,dx,4))
dx=dx+4
END FUNCTION
	

' read a hunk, setting up headertype&,headersize& and headerdata$
SUB ReadHunk
SHARED dx,d$
SHARED headertype&,headersize&,headerdata$
	headertype&=ReadLong&
' these types need their own parsing routines as they don't use the same length info
	IF (headertype&<>HUNK_END&) AND _
	  (headertype&<>HUNK_EXT&) AND _
	  (headertype&<>HUNK_SYMBOL&) AND _
	  (headertype&<>HUNK_HEADER&)  THEN
		headersize&=ReadLong& AND &H3FFFFF&
		headerdata$=MID$(d$,dx,4*headersize&)
		dx=dx+4*headersize&
	END IF
END SUB

SUB ReadHunkHeader
	SHARED dx, d$
	SHARED headertype&, headersize&, headerdata$

	headersize& = ReadLong&		' length of the resident library name
	WHILE headersize& <> 0
		dx = dx + 4 * headersize&	' skip over it
		headersize& = ReadLong&		' length of the resident library name
	WEND
	headersize& = ReadLong&		' number of hunks
	dx = dx + 4 * (headersize& + 2)	' skip sizes, first & last hunk slots
END SUB

SUB ReadExtSym(BYVAL ExtFlag)
SHARED ourname$,dx,dlen,d$,junk&
STATIC typ,namelen,symname$,i,namelen&
	DO UNTIL dx>dlen
		typ=ReadByte
		namelen&=CVL(CHR$(0)+MID$(d$,dx,3))
		IF namelen&>32767 THEN PRINT "file corrupt": STOP
		dx=dx+3
		namelen=namelen&
		IF namelen=0 THEN	EXIT SUB
		symname$=MID$(d$,dx,namelen*4): dx=dx+namelen*4
		i=INSTR(symname$,CHR$(0))
		IF i THEN
			symname$=LEFT$(symname$,i-1)
		END IF
		IF LEFT$(symname$,1)="_" THEN symname$=MID$(symname$,2)
		SELECT CASE typ
		CASE EXT_DEF&:		
			IF ourname$="" THEN
				ourname$=symname$
				IF ReadLong&<>0 THEN
						PRINT "Routines must start at the beginning" :STOP
				END IF
			ELSEIF ReadLong&<>0 THEN
				PRINT "more than one routine defined": STOP
			END IF
		CASE ELSE:
				IF NOT ExtFlag THEN
					junk&=ReadLong&
				ELSE
					PRINT "can't handle ";typ;" in HUNK_EXT": STOP
				END IF
		END SELECT
	LOOP
END SUB

